package cn.com.infosec.crypto.examples;

import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.engines.DESedeEngine;
import cn.com.infosec.crypto.generators.DESedeKeyGenerator;
import cn.com.infosec.crypto.modes.CBCBlockCipher;
import cn.com.infosec.crypto.paddings.PaddedBufferedBlockCipher;
import cn.com.infosec.util.encoders.Hex;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.SecureRandom;

public class DESExample {
   private boolean encrypt;
   private PaddedBufferedBlockCipher cipher;
   private BufferedInputStream in;
   private BufferedOutputStream out;
   private byte[] key;

   public static void main(String[] args) {
      boolean var1 = true;
      if (args.length < 2) {
         new DESExample();
         System.err.println("Usage: java " + DESExample.class.getName() + " infile outfile [keyfile]");
         System.exit(1);
      }

      String var2 = "deskey.dat";
      String var3 = args[0];
      String var4 = args[1];
      if (args.length > 2) {
         var1 = false;
         var2 = args[2];
      }

      (new DESExample(var3, var4, var2, var1)).process();
   }

   public DESExample() {
      this.encrypt = true;
      this.cipher = null;
      this.in = null;
      this.out = null;
      this.key = null;
   }

   public DESExample(String infile, String outfile, String keyfile, boolean encrypt) {
      DESExample var10000 = this;
      super();
      this.encrypt = true;
      this.cipher = null;
      this.in = null;
      this.out = null;
      this.key = null;
      this.encrypt = encrypt;

      try {
         var10000.in = new BufferedInputStream(new FileInputStream(infile));
      } catch (FileNotFoundException var6) {
         System.err.println("Input file not found [" + infile + "]");
         System.exit(1);
      }

      try {
         this.out = new BufferedOutputStream(new FileOutputStream(outfile));
      } catch (IOException var5) {
         System.err.println("Output file not created [" + outfile + "]");
         System.exit(1);
      }

      boolean var10001;
      int var20;
      if (encrypt) {
         infile = null;

         label127: {
            SecureRandom outfile1;
            label118: {
               label117: {
                  SecureRandom var24;
                  label116: {
                     label128: {
                        try {
                           var24 = new SecureRandom;
                        } catch (Exception var19) {
                           var10001 = false;
                           break label128;
                        }

                        SecureRandom var26 = outfile1 = var24;

                        try {
                           var26.<init>();
                           break label116;
                        } catch (Exception var18) {
                           var10001 = false;
                        }
                     }

                     outfile1 = infile;
                     break label117;
                  }

                  try {
                     var24.setSeed("www.Infosec.org".getBytes());
                     break label118;
                  } catch (Exception var17) {
                  }
               }

               try {
                  System.err.println("Hmmm, no SHA1PRNG, you need the Sun implementation");
                  System.exit(1);
               } catch (IOException var16) {
                  var10001 = false;
                  break label127;
               }
            }

            KeyGenerationParameters var29;
            try {
               var10000 = this;
               var29 = new KeyGenerationParameters;
            } catch (IOException var15) {
               var10001 = false;
               break label127;
            }

            KeyGenerationParameters infile1 = var29;

            DESedeKeyGenerator var31;
            try {
               var29.<init>(outfile1, 192);
               var31 = new DESedeKeyGenerator;
            } catch (IOException var14) {
               var10001 = false;
               break label127;
            }

            DESedeKeyGenerator var10002 = var31;
            DESedeKeyGenerator var10003 = var31;

            BufferedOutputStream var25;
            try {
               var10003.<init>();
               var10002.init(infile1);
               var10000.key = var31.generateKey();
               var25 = new BufferedOutputStream;
            } catch (IOException var13) {
               var10001 = false;
               break label127;
            }

            BufferedOutputStream var34 = var25;
            BufferedOutputStream var27 = var25;
            BufferedOutputStream var32 = var25;

            byte[] var33;
            try {
               var32.<init>(new FileOutputStream(keyfile));
               var33 = Hex.encode(this.key);
            } catch (IOException var12) {
               var10001 = false;
               break label127;
            }

            byte[] var10004 = var33;
            var20 = 0;

            try {
               var27.write(var33, var20, var10004.length);
               var34.flush();
               var25.close();
               return;
            } catch (IOException var11) {
               var10001 = false;
            }
         }

         System.err.println("Could not decryption create key file [" + keyfile + "]");
         System.exit(1);
      } else {
         label129: {
            int var28;
            BufferedInputStream var35;
            try {
               var10000 = this;
               var35 = new BufferedInputStream(new FileInputStream(keyfile));
               var28 = var35.available();
            } catch (IOException var10) {
               var10001 = false;
               break label129;
            }

            var20 = var28;

            byte[] var30;
            try {
               var30 = new byte[var28];
            } catch (IOException var9) {
               var10001 = false;
               break label129;
            }

            byte[] infile2 = var30;

            try {
               var35.read(var30, 0, var20);
            } catch (IOException var8) {
               var10001 = false;
               break label129;
            }

            try {
               var10000.key = Hex.decode(infile2);
               return;
            } catch (IOException var7) {
               var10001 = false;
            }
         }

         System.err.println("Decryption key file not found, or not valid [" + keyfile + "]");
         System.exit(1);
      }

   }

   private final void process() {
      this.cipher = new PaddedBufferedBlockCipher(new CBCBlockCipher(new DESedeEngine()));
      if (this.encrypt) {
         this.performEncrypt(this.key);
      } else {
         this.performDecrypt(this.key);
      }

      try {
         this.in.close();
         this.out.flush();
         this.out.close();
      } catch (IOException var1) {
      }

   }

   private final void performEncrypt(byte[] param1) {
      // $FF: Couldn't be decompiled
   }

   private final void performDecrypt(byte[] param1) {
      // $FF: Couldn't be decompiled
   }
}
